/* mechanically-generated file -- do not edit */
'dummy string to turn off strict mode';
(function ($) {
'use strict';

var event_namespace = '.kingfisher-scinap';

var non_shorthand_CSS_colour_properties =
  'color backgroundColor outlineColor \
    borderTopColor borderBottomColor borderLeftColor \
    borderRightColor'.split(/\s+/);

var CSS_colour_properties =
  non_shorthand_CSS_colour_properties.concat('borderColor');

var properties_in_display_order;
var colour_properties_in_textarea_order;

var check_mark = '\u2713';
var error_mark = '\u2717';

var phpjs = new PHP_JS;

var config_val = {};

(
  function () {
    var scripts = document.getElementsByTagName('script');
    var script = scripts[scripts.length - 1];
    var script_path = script.src;

    window.scinap = function (config_val_from_user) {
      $(
	function () {
	  main(config_val_from_user, script_path)
	}
      );
    };
  }
)();

function main(config_val_from_user, script_path) {
  /*>
    The names here are public, hence the American spellings
  */
  var default_config_val = {
    economise_on_colors: true,
    restore_colors: false,
    use_color_keywords: false,
    initial_initiator_position: {
      bottom: '5ex',
      right: '5ex'
    }
  };

  obj_extend(config_val, default_config_val);
  obj_extend(config_val, config_val_from_user);

  if(!config_val.hasOwnProperty('stylesheet_selector')) {
    throw new Error('stylesheet_selector not specified');
  }

  var type = $.type(config_val.stylesheet_selector);
  if(type !== 'string') {
    throw new Error('type of stylesheet_selector should be ' +
      'string, but is actually ' + type);
  }

  for(var prop in
    'economise_on_colors restore_colors use_color_keywords'.split(' ')) {

    config_val[prop] = Boolean(config_val[prop]);
  }

  obj_restrict(config_val.initial_initiator_position,
    'top bottom right left'.split(' '));
  
  var size = Math.max(7, Math.min(32, Math.ceil(pixel_size('1em'))));
  var dropper_cursor_class = nsc('dropper-cursor-' + size);

  var script_dir =
    /\//.test(script_path)? script_path.replace(/\/[^/]+$/, ''): '.';
  var cursor_style_element =
    load_style_string(
      phpjs.sprintf(
	' \
	  body.%1$s .%2$s { \
	    cursor: url(%6$s/cursors/dropper-%5$s.png), default; \
	  } \
	  body.%1$s .%3$s, \
	  body.%1$s .%4$s \
	  { \
	    cursor: url(%6$s/cursors/dropper-%5$s.png), default; \
	  } \
	', dropper_cursor_class,
	
	  nsc('CSS-color-setter-app'),
	  /*<
	    this CSS class is used for every "top-level" item
	    introduced by this software into the web page.
	  */

	  nsc('colour-patch'), nsc('copy-button'), size,
	  script_dir
      )
    );

  var colour_clipboard =
    (
      function () {
	var CSS_class = dropper_cursor_class;
	var document_body = $('body');

	return {
	  colour: null,

	  get: function () { return this.colour; },

	  put: function (colour) {
	    this.colour = colour;
	    document_body.addClass(CSS_class);
	  },
	  empty: function () {
	    this.colour = null;
	    document_body.removeClass(CSS_class);
	  },
	  is_empty: function () { return this.colour === null; }
	};
      }
    )();

  $('body').delegate(
    nsc('.CSS-color-setter-app'),
    'click' + event_namespace,
    function () { colour_clipboard.empty(); }
  );

  var initiator = $('<div/>').addClass(nsc('initiator'));
  var colour_dialog_opener = $('<div/>').addClass(nsc('opener'));
  var terminator = $('<div/>').addClass(nsc('terminator'));
  initiator.append(
    $('<div/>').addClass(nsc('handle')),
    colour_dialog_opener,
    terminator
  );
  initiator.draggable(
    {
      containment: 'window',
      handle: '.handle',
      iframeFix: true,
      scroll: false
    }
  );

  var positioner =
    $('<div/>').addClass(nsc('CSS-color-setter-app initiator-positioner')).
      css(config_val.initial_initiator_position).
      append(initiator);
  $('body').append(positioner);

  var selector = config_val.stylesheet_selector;
  var stylesheets_specified = $(selector); 
  if(stylesheets_specified.length !== 1) {
    throw new Error('problem with selector "' + selector +
      '": should specify 1 stylesheet, actually specifies ' +
      stylesheets_specified.length);
  }

  var stylesheet_rules = get_stylesheet_rules(stylesheets_specified);

  var rules_internal = [];

  $.each(
    stylesheet_rules,

    function (index, style_rule) {
      var rule = {
	selector_text: style_rule.selectorText,

	propval: {},

	border_colour_dependencies_exist:
	  normalise_val(style_rule.style.borderColor) !== '',

	interdependent_declarations: []
      };

      if(rule.border_colour_dependencies_exist) {
	rule.border_colour_manager =
	  new Border_colour_manager(rule.propval);
      }

      rules_internal[index] = rule;

      $.each(
	non_shorthand_CSS_colour_properties,
	function (dummy, prop_name) {
	  var normalised = normalise_val(style_rule.style[prop_name]);
	  if(normalised !== '')
	    rules_internal[index].propval[prop_name] =
	      standardised_colour(normalised);
	}
      );
    }
  );

  var restore_colours_if_desired = $.noop;

  if(config_val.restore_colors) {
    restore_colours_if_desired = (
      function () {
	var saved_propvals = [];

	$.each(
	  stylesheet_rules,

	  function (rule_index, style_rule) {
	    $.each(
	      non_shorthand_CSS_colour_properties,
	      function (dummy, prop_name) {
		var val = style_rule.style[prop_name];
		var normalised = normalise_val(val);
		if(normalised !== '') {
		  if(!saved_propvals.hasOwnProperty(rule_index))
		    saved_propvals[rule_index] = {};

		  saved_propvals[rule_index][prop_name] = val;
		}
	      }
	    );
	  }
	);

	return function () {
	  $.each(
	    saved_propvals,
	    function (rule_index, propval) {
	      obj_iter(
		propval,
		function (prop_name, val) {
		  stylesheet_rules[rule_index].style[prop_name] = val;
		}
	      );
	    }
	  );
	};
      }
    )();
  }

  var CSS_property_dialog = $('<div/>');

  $.each(
    rules_internal,

    function (rule_index, internal_rule) {
      var declaration_block =
	$('<div/>').addClass(nsc('declaration-block')).
	  append(
	    $('<div/>').addClass(nsc('selector')).
	      html(internal_rule.selector_text)
	  );

      var declaration_div = {};

      if(internal_rule.border_colour_dependencies_exist) {
	for(var i = 1; i <= 4; i++) {
	  var prop_name = 'border-color' + i;

	  var
	    declaration = $('<div/>').addClass(nsc('declaration')).
	      append(
		$('<span/>').
		  addClass(nsc('accuracy-indicator-space-maker')).
		  append(
		    $('<span/>').addClass(nsc('accuracy-indicator'))
		  ),

		$('<span/>').addClass(nsc('prop-name')).
		  text(prop_name)
	      );

	  declaration_div[prop_name] = declaration;
	  internal_rule.interdependent_declarations[i] = declaration;

	  for(var j = 1; j <= i; j++) {
	    declaration.append(
	      new_text_node(' '),

	      $('<span/>').addClass(nsc('colour-patch')).
		data('patch_info',
		  {
		    rule_index: rule_index,

		    dependencies_exist: true,
		    num_args: i,
		    patch_index: j - 1
		  }
		)
	    );
	  }
	}

	update_border_properties(rule_index);
      }

      var is_border_prop =
	function (prop_name) {
	  var result =
	    in_array(prop_name,
	      Border_colour_manager.border_property_names_in_order);
	  return result;
	};

      $.each(
	CSS_colour_properties,

	function (dummy, prop_name) {
	  if(
	    internal_rule.propval.hasOwnProperty(prop_name) &&
	      (!is_border_prop(prop_name) ||
		!internal_rule.border_colour_dependencies_exist))
	  {
	    declaration_div[prop_name] =
	      $('<div/>').addClass(nsc('declaration')).
		append(
		  $('<span/>').addClass(nsc('prop-name')).
		    text(hyphenated_version(prop_name)),

		  new_text_node(' '),

		  $('<span/>').addClass(nsc('colour-patch')).
		    css('background-color',
		      internal_rule.propval[prop_name]).
		    data('patch_info',
		      {
			rule_index: rule_index,
			prop_name: prop_name,

			dependencies_exist: false,
		      }
		    )
		);
	  }
	}
      );

      $.each(
	properties_in_display_order,

	function (dummy, prop_name) {
	  if(declaration_div.hasOwnProperty(prop_name))
	    declaration_block.append(declaration_div[prop_name]);
	}
      );

      $(nsc('.colour-patch'), declaration_block).each(
	function () {
	  var patch = $(this);
	  patch.after(
	    $('<span/>').addClass(nsc('copy-button')).
	      html('&nbsp;copy').
	      bind(
		'click' + event_namespace,
		function (e) {
		  e.stopPropagation();
		  colour_clipboard.put(get_patch_colour(patch));
		}
	      )
	  );
	}
      );

      CSS_property_dialog.append(declaration_block);
    }
  );

  CSS_property_dialog.appendTo('body');

  $(nsc('.colour-patch')).
    bind(
      'click' + event_namespace,
      function (e) {
	var patch = $(this);
	
	e.stopPropagation();
	/*
	  to stop the colour clipboard being emptied
	*/

	if(!colour_clipboard.is_empty()) {
	  change_colours(patch, colour_clipboard.get());
	} else {
	  get_colour_from_user(
	    function (colour) {
	      assert(colour === standardised_colour(colour));
	      change_colours(patch, colour);
	    }
	  );
	}
      }
    );
    
  CSS_property_dialog.dialog(
    {
      title: 'Modify CSS colours',
      autoOpen: false,
      closeOnEscape: false,
      dialogClass: nsc('dialog CSS-color-setter-app'),
      open: function () {
	var thisjq = $(this);

	if(!thisjq.data('initialised')) {
	  thisjq.css('cursor', '');
	  var real_dialog_box = thisjq.closest('.ui-dialog');
	  var real_width = real_dialog_box.width(); 
          var real_height = real_dialog_box.height(); 
          var width_diff = real_width - thisjq.width();
	  var height_diff = real_height - thisjq.height();
	  var pixel_width = { ex: pixel_size('1ex') };

	  var buttons = real_dialog_box.find('button');
	  assert(buttons.length > 0);
	  var max_button_width = 
	    Math.max.apply(Math, buttons.map(
	      function () { return $(this).width(); }).get());
	  
	  thisjq.dialog('option',
	    {
	      width:
		Math.max(max_button_width,
		  width_diff + 50 * pixel_width.ex),
	      height: height_diff + 28 * pixel_width.ex
	    }
	  );
	  thisjq.dialog('option', 'position', 'center');
	  thisjq.data('initialised', true);
	}
      },

      buttons: {
	'Get CSS rules':
	  function () {
	    var textarea_text =
	      $.map(
		rules_internal,

		function (rule) {
		  var propval = obj_copy(rule.propval);

		  if(rule.border_colour_dependencies_exist) {
		    $.each(
		      Border_colour_manager.
			border_property_names_in_order,

		      function (dummy, prop_name) {
			delete propval[prop_name];
		      }
		    );

		    var econ_colours = config_val.economise_on_colors;

		    obj_extend(
		      propval,
		      rule.border_colour_manager.
			best_representative(econ_colours)
		    );
		  }

		  /*
		    lines in the textarea need to be terminated by
		    CRLF, not LF; otherwise, IE8 doesn't show the line
		    breaks.
		  */
		  return rule.selector_text + ' {\r\n' +
		    $.map(
		      colour_properties_in_textarea_order,
		      function (prop_name) {
			if(!propval.hasOwnProperty(prop_name)) {
			  return '';
			} else {
			  var val = propval[prop_name];

			  if(config_val.use_color_keywords) {
			    val =
			      $.map(
				$.trim(val).split(/\s+/),
				function (colour) {
				  return as_keyword_if_possible(colour);
				}
			      ).join(' ');
			  }

			  var result =
			    phpjs.sprintf('%2s%s: %s;\r\n', ' ',
			      hyphenated_version(prop_name), val);
			  return result;
			}
		      }
		    ).join('');
		}
	      ).concat('').join('}\r\n\r\n');

	      $('<textarea/>', { rows: 6, cols: 10 }).
		addClass(nsc('stylesheet-textarea')). 
		text(textarea_text).
		dialog(
		  {
		    title: 'Copy and paste&hellip;',
		    closeOnEscape: false,
		    dialogClass: nsc('CSS-color-setter-app dialog \
		      stylesheet-dialog'), 
		    width: 'auto',
		    close:
		      function () {
			$(this).dialog('destroy').remove();
		      }
		  }
		);
	  }
      },

      close: function () { initiator.show(); }
    }
  );

  colour_dialog_opener.bind(
    'click' + event_namespace,
    function () {
      initiator.hide();
      CSS_property_dialog.dialog('open');
    }
  );
  terminator.one(
    'click' + event_namespace,
    function () {
      restore_colours_if_desired();
      CSS_property_dialog.dialog('destroy').remove();
      $(cursor_style_element).remove();
      initiator.remove();
      $('*').unbind(event_namespace);
      $('body').undelegate(
	nsc('.CSS-color-setter-app'),
	'click' + event_namespace
      );
    }
  );
  //colour_dialog_opener.click();

  function change_colours(patch, new_colour) {
    var patch_info = patch.data('patch_info');

    if(patch_info.dependencies_exist) {
      var border_colour_manager =
	rules_internal[patch_info.rule_index].border_colour_manager;
      var colours =
	border_colour_manager.get_colours(patch_info.num_args);
      colours[patch_info.patch_index] = new_colour;
      border_colour_manager.set_colours(colours);

      update_border_properties(patch_info.rule_index);

      var rule = stylesheet_rules[patch_info.rule_index];

      border_colour_manager.set_stylesheet_colours(rule);
    } else {
      /*
	there are 3 distinct colours we need to change
      */

      var internal_rule = rules_internal[patch_info.rule_index];
      internal_rule.propval[patch_info.prop_name] = new_colour;

      patch.css('background-color', new_colour);

      stylesheet_rules[patch_info.rule_index].
	style[patch_info.prop_name] = new_colour;
    }
  }

  function update_border_properties(rule_index) {
    var internal_rule = rules_internal[rule_index];

    assert(internal_rule.border_colour_dependencies_exist);

    var border_colour_manager = internal_rule.border_colour_manager;

    for(var i = 1; i <= 4; i++) {
      var declaration = internal_rule.interdependent_declarations[i];
      var patches = declaration.find(nsc('.colour-patch'));
      var new_patch_colours = border_colour_manager.get_colours(i);

      $.each(
	new_patch_colours,

	function (index, colour) {
	  patches.eq(index).css('background-color', colour);
	}
      );

      var accuracy_indicator =
	declaration.find(nsc('.accuracy-indicator'));

      if(border_colour_manager.correctly_represented_by(i)) {
	accuracy_indicator.text(check_mark).css('color', 'lime');
      } else
	accuracy_indicator.text(error_mark).css('color', 'red');
    }
  }

  function get_patch_colour(patch) {
    var patch_info = patch.data('patch_info');
    var rule = rules_internal[patch_info.rule_index];

    if(patch_info.dependencies_exist) {
      var manager = rule.border_colour_manager;
      var colours = manager.get_colours(patch_info.num_args);
      return colours[patch_info.patch_index];
    } else {
      return rule.propval[patch_info.prop_name];
    }
  }
}

function get_colour_from_user(callback) {
  var colour_square_side_len = Math.ceil(pixel_size('1.2em'));
  var num_points_in_slice_side = 9;
  var num_points_in_slice_side = 4;
  assert(is_perfect_square(num_points_in_slice_side));
  var sqrt = Math.round(Math.sqrt(num_points_in_slice_side));
  necessary(sqrt * sqrt === num_points_in_slice_side);
  var num_squares_in_display_square_side =
    num_points_in_slice_side * sqrt;
  var container_side_len =
    num_squares_in_display_square_side * colour_square_side_len; 

  function doit() {
    var testing = (
      function () { return this !== undefined && this.testing; }
    )();

    if(testing) {
      print(change_dimensions([0], 3));
      pr_array(change_dimensions.indices[3]);
    } else {
      var colour_dialog_content = $('<div/>').
	addClass(nsc('colour-dialog-content'));

      var colour_container =
	$('<div/>').css(
	  {
	    position: 'relative',
	    width: container_side_len,
	    height: container_side_len
	  }
	);

      $('<div/>').
	css(
	  {
	    width: container_side_len,
	    height: container_side_len,
	    borderStyle: 'solid',
	    borderWidth: 'thick',
	    borderColor: 'black'
	  }
	).
	append(colour_container).appendTo(colour_dialog_content);

      var colour_history_boxes = [
	new Colour_history_box('current'),
	new Colour_history_box('previous')
      ];

      colour_dialog_content.append(
	colour_history_boxes[1].get_root(),
	colour_history_boxes[0].get_root()
      );

      var colour_squares = [];

      for(var i = 0; i < num_squares_in_display_square_side; i++) {
	for(var j = 0; j < num_squares_in_display_square_side; j++) {
	  var colour_square = $('<div/>').css(
	    {
	      position: 'absolute',
	      top: i * colour_square_side_len,
	      left: j * colour_square_side_len,
	      width: colour_square_side_len,
	      height: colour_square_side_len
	    }
	  );
	  colour_squares.push(colour_square);
	}
      }

      var cube = { side_len: 255 };
      var tmp =
	Math.floor((num_points_in_slice_side - 1) / 2) /
	(num_points_in_slice_side - 1) *
	cube.side_len;
      cube.colours = [tmp, tmp, tmp];
      cube.get_colour =
	function (red_index, green_index, blue_index) {
	  var d = this.side_len / (num_points_in_slice_side - 1);
	  var index_change =
	    Math.floor((num_points_in_slice_side - 1) / 2);
	  return new Colour(
	    clip(Math.round(this.colours[0] +
	      (red_index - index_change) * d)),
	    clip(Math.round(this.colours[1] +
	      (green_index - index_change) * d)),
	    clip(Math.round(this.colours[2] +
	      (blue_index - index_change) * d))
	  );
	};
      cube.get_current_colour =
	function () {
	  return new Colour(
	    clip(Math.round(this.colours[0])),
	    clip(Math.round(this.colours[1])),
	    clip(Math.round(this.colours[2]))
	  );
	};
      cube.process_click =
	function (red_index, green_index, blue_index) {
	  if(this.side_len >= .5) {
	    this.colours =
	      this.get_colour.apply(this, arguments).get_components();
	    this.side_len /= 2;
	  }
	};

      var set_square_colours =
	function () {
	  for(var red_index = 0; red_index < num_points_in_slice_side;
	    red_index++)
	  {
	    for(var green_index = 0; green_index < num_points_in_slice_side;
	      green_index++)
	    {
	      for(var blue_index = 0; blue_index < num_points_in_slice_side;
		blue_index++)
	      {
		var colour = '#' +
		  cube.get_colour(red_index, green_index, blue_index).hex();

		var index =
		  change_dimensions([red_index, green_index, blue_index],
		    1)[0];
		var square = colour_squares[index];
		square.css({ backgroundColor: colour });
	      }
	    }
	  }
	};

      set_square_colours();

      var maintain_colour_history =
	function callee() {
	  if(!callee.hasOwnProperty('colour_history'))
	    callee.colour_history = [];

	  var colour_history = callee.colour_history;

	  if(colour_history.length == colour_history_boxes.length)
	    colour_history.pop();

	  colour_history.unshift(
	    {
	      bg: cube.get_current_colour().hex(),
	      fg: cube.get_current_colour().contrasting().hex()
	    }
	  );

	  for(var i = 0; i < colour_history.length; i++) {
	    var box = colour_history_boxes[i];
	    box.set_colour('#' + colour_history[i].bg);
	    box.get_root().
	      css({
		backgroundColor: '#' + colour_history[i].bg,
		color: '#' + colour_history[i].fg
	      });
	  }
	};

      maintain_colour_history();

      $.each(colour_squares,
	function (dummy, colour_square) {
	  colour_container.append(colour_square);
	}
      );

      colour_container.bind(
	'click' + event_namespace,

	function (e) {
	  var thisjq = $(this);
	  var x = e.pageX - thisjq.offset().left - 1;
	  var y = e.pageY - thisjq.offset().top - 1;
	  function f(n) {
	    var result =
	      (n - (n % colour_square_side_len)) / colour_square_side_len;
	    return result;
	  }
	  var row = f(y);
	  var col = f(x);
	  var indices = change_dimensions([row, col], 3);
	  cube.process_click.apply(cube, indices);
	  set_square_colours();
	  maintain_colour_history();
	}
      );

      colour_dialog_content.dialog({
	title: 'Pick a colour',
	dialogClass:
	  nsc('CSS-color-setter-app dialog colour-picker-dialog'),
	closeOnEscape: false,
	buttons: {
	  'Use current colour':
	    function () {
	      callback('#' + cube.get_current_colour().hex());
	      $(this).dialog('destroy').remove();
	    }
	},
	open: function () {
	  var thisjq = $(this);

	  if(!thisjq.data('width_initialised')) {
	    set_dialog_content_width(thisjq,
	      max_child_width(thisjq) + pixel_size('7ex'));
	    thisjq.data('width_initialised', true);
	  }
	}
      });
    }
  }

  function change_dimensions(indices, new_dimensionality) {
    var callee = change_dimensions;

    if(!callee.hasOwnProperty('indices')) {
      callee.indices = [];
      callee.indices[2] = [];
      callee.indices[3] = [];

      for(var i = 0; i < num_squares_in_display_square_side; i++) {
	for(var j = 0; j < num_squares_in_display_square_side; j++) {
	  var one_dimensional = to_one_dimensional([i, j]);
	  callee.indices[2][one_dimensional] = [i, j];
	}
      }

      for(var i = 0; i < num_points_in_slice_side; i++) {
	for(var j = 0; j < num_points_in_slice_side; j++) {
	  for(var k = 0; k < num_points_in_slice_side; k++) {
	    var one_dimensional = to_one_dimensional([i, j, k]);
	    callee.indices[3][one_dimensional] = [i, j, k];
	  }
	}
      }
    }

    var one_dimensional = to_one_dimensional(indices);

    if(new_dimensionality === 1) {
      return [one_dimensional];
    } else {
      return callee.indices[new_dimensionality][one_dimensional];
    }

    function to_one_dimensional(indices) {
      switch(indices.length) {
	case 1:
	  return indices[0];
	break;

	case 2:
	  var result =
	    num_squares_in_display_square_side * indices[0] + indices[1];
	  return result;
	break;

	case 3:
	  /*
	    one might say that we are working with 3 levels
	    of squares: the coloured squares, the "display square",
	    and a level in between (call
	    it level 2).  the variables `col' and `row'
	    here apply to level 2: they
	    identify the square that we are in at level 2.
	  */
	  var col = indices[2] % sqrt;
	  var row = (indices[2] - col) / sqrt;
	  var result =
	    /*
	      this expression counts how many slices through the
	      colour cube are "behind us"...
	    */
	    num_points_in_slice_side * num_points_in_slice_side *
	      sqrt * row +
	    /*
	      and this expression
	      counts how many rows in the "display
	      square" are "behind us", not counting those rows which
	      we have counted with the previous expression.
	    */
	    indices[1] * num_points_in_slice_side * sqrt +
	    /*
	      we are in some row in the "display square".
	      the next expression counts how many squares
	      in this row are "behind us".
	    */
	    col * num_points_in_slice_side + indices[0];
	  return result;
	break;
      }
    }
  }

  var Colour = create_class(
    function (red, green, blue) {
      this.colours = [red, green, blue];
    },

    {
      contrasting: function () {
	var contrasting = new Array(3);
	var top = 255;
	for(var i = 0; i < this.colours.length; i++) {
	  contrasting[i] = this.colours[i] < top / 2? top: 0;
	}
	var result = new Colour();
	result.colours = contrasting;
	return result;
      },

      get_components: function () {
	return this.colours.concat();
      },

      hex: function () {
	return phpjs.vsprintf('%02x%02x%02x', this.colours);
      }
    }
  );

  var Colour_history_box = create_class(
    function (description) {
      this.colour_box = $('<div/>').addClass(nsc('colour'));

      this.root =
	$('<div/>').addClass(nsc('colour-history-box')).append(
	  $('<div/>').addClass(nsc('description')).text(description),
	  this.colour_box.text(phpjs.str_repeat('-', 7))
	);
    },

    {
      set_colour: function (new_colour) {
	this.colour_box.text(new_colour);
      },

      get_root: function () {
	return this.root;
      }
    }
  );

  function is_perfect_square(x) {
    assert(({}).toString.call(x) === '[object Number]');

    return isFinite(x) && x === Math.floor(x) &&
      Math.pow(Math.round(Math.sqrt(x)), 2) === x;
  }

  function clip(colour) {
    return Math.max(0, Math.min(255, colour));
  }

  doit.apply(this, arguments);
}

function normalise_val(property_value) {
  if(property_value == null) {
    return '';
  } else
    return property_value.toString();
}

function get_stylesheet_rules(stylesheet_element) {
  var DOM_node = stylesheet_element.get(0);
  var sheet = DOM_node.sheet || DOM_node.styleSheet;
  return sheet.cssRules || sheet.rules;
}

function new_text_node(text) {
  var tmp = $('<span/>').text(text);
  var text_obj = tmp.contents();
  text_obj.unwrap();
  return text_obj;
}

function copy_elems(array) {
  var new_array = new Array(arguments.length - 1);
  for(var i = 1; i < arguments.length; i++)
    new_array[i - 1] = array[arguments[i]];
  return new_array;
}

var Border_colour_manager = create_class(
  {
    border_property_names_in_order:
      'borderTopColor borderRightColor borderBottomColor \
	borderLeftColor'.split(/\s+/),

    // generated mechanically, but later changed by hand
    most_economical_on_colours: {
      '0000': { border_color_indices: [0], corrections: [] },
      '0001': { border_color_indices: [0], corrections: [3] },
      '0010': { border_color_indices: [0], corrections: [2] },
      '0011': { border_color_indices: [0], corrections: [2, 3] },
      '0012': { border_color_indices: [0], corrections: [2, 3] },
      '0100': { border_color_indices: [0], corrections: [1] },
      '0101': { border_color_indices: [0, 1], corrections: [] },
      '0102': { border_color_indices: [0], corrections: [1, 3] },
      '0110': { border_color_indices: [0], corrections: [1, 2] },
      '0111': { border_color_indices: [1], corrections: [0] },
      '0112': { border_color_indices: [1], corrections: [0, 3] },
      '0120': { border_color_indices: [0], corrections: [1, 2] },
      '0121': { border_color_indices: [0, 1, 2], corrections: [] },
      '0122': { border_color_indices: [2], corrections: [0, 1] },
      '0123': { border_color_indices: [0, 1, 2, 3], corrections: [] }
    }
  },

  function (propval_or_colours) {
    switch($.type(arguments[0])) {
      case 'object':
	this.propval = arguments[0];
      break;

      case 'array':
	assert(arguments[0].length >= 1);
	assert(arguments[0].length <= 4);
	this.propval = {};
	this.set_colours(arguments[0]);
      break;

      default:
	throw new Error('unexpected type: ' + $.type(arguments[0]));
    }
  },

  {
    get_colours:
      function (num_args_to_CSS_property) {
	var wanted_indices = [
	  null,
	  [0],
	  [0, 1],
	  [0, 1, 2],
	  [0, 1, 2, 3]
	];

	var that = this;

	return $.map(
	  wanted_indices[num_args_to_CSS_property],
	  function (index_in_properties) {
	    var prop_name =
	      Border_colour_manager.
		border_property_names_in_order[index_in_properties];
	    var val = that.propval[prop_name];
	    assert(val != null);
	    return val;
	  }
	);
      },

    set_colours:
      function (colours) {
	var indices_to_set_from = [
	  null,
	  [0, 0, 0, 0],
	  [0, 1, 0, 1],
	  [0, 1, 2, 1],
	  [0, 1, 2, 3]
	];

	var indices = indices_to_set_from[colours.length];

	var that = this;

	$.each(
	  Border_colour_manager.border_property_names_in_order,
	  function (index, prop_name) {
	    that.propval[prop_name] = colours[indices[index]];
	  }
	);
      },

    shortest_representative:
      function () {
	for(var i = 1; i <= 4; i++)
	  if(this.correctly_represented_by(i))
	    return this.get_colours(i);
	assert(false, 'we should never get here');
      },

    best_representative: function (economise_on_colours) {
      if(economise_on_colours) {
	var best = 
	  Border_colour_manager.
	    most_economical_on_colours[this.distinctness()];
	assert($.type(best) === 'object');
	var colours = this.get_colours(4);
	var result = {
	  borderColor:
	    $.map(
	      best.border_color_indices,
	      function (border_index) {
		return colours[border_index];
	      }
	    ).join(' ')
	};
	$.each(
	  best.corrections,
	  function (dummy, border_index) {
	    var prop_name =
	      Border_colour_manager.
		border_property_names_in_order[border_index];
	    result[prop_name] = colours[border_index];
	  }
	);
	return result;
      } else {
	return {
	  borderColor: this.shortest_representative().join(' ')
	};
      }
    },

    distinctness: function () {
      var indices = '';
      var colour_num = {};
      var distinct_seen = 0;
      $.each(
	this.get_colours(4),
	function (dummy, colour) {
	  if(!colour_num.hasOwnProperty(colour)) {
	    colour_num[colour] = distinct_seen;
	    distinct_seen++;
	  }

	  indices += colour_num[colour];
	}
      );

      return indices;
    },

    correctly_represented_by:
      function (num_colours) {
	var colours = this.get_colours(num_colours);
	var tmp = new Border_colour_manager(colours);
	return this.borders_equal(tmp);
      },

    borders_equal: function (other) {
      return as_string(this) === as_string(other);

      /*
	this could be made a method, but i think it's better
	to have it here
      */
      function as_string(border_colour_manager) {
	var propval = border_colour_manager.propval;
	var result =
	  $.map(
	    Border_colour_manager.border_property_names_in_order,
	    function (prop_name) {
	      if(propval.hasOwnProperty(prop_name))
		assert(propval[prop_name].indexOf('\n') === -1); 
		return prop_name + '\n' + propval[prop_name] + '\n';
	    }
	  ).join('');
	return result;
      }
    },

    set_stylesheet_colours: function (stylesheet_rule) {
      var that = this;

      $.each(
	Border_colour_manager.border_property_names_in_order,

	function (dummy, prop_name) {
	  stylesheet_rule.style[prop_name] = that.propval[prop_name];
	}
      );
    },
  }
);

properties_in_display_order = 
    'color backgroundColor'.split(' ').concat(
      '1 2 3 4'.replace(/\d/g, 'border-color$&').split(' '),
      Border_colour_manager.border_property_names_in_order,
      'outlineColor'
    );
colour_properties_in_textarea_order =
    'color backgroundColor borderColor'.split(' ').concat(
      Border_colour_manager.border_property_names_in_order,
      'outlineColor'
    );

var keyword_to_hex_colour = {
  aqua: '#00ffff',
  black: '#000000',
  blue: '#0000ff',
  fuchsia: '#ff00ff',
  gray: '#808080',
  green: '#008000',
  lime: '#00ff00',
  maroon: '#800000',
  navy: '#000080',
  olive: '#808000',
  orange: '#ffA500',
  purple: '#800080',
  red: '#ff0000',
  silver: '#c0c0c0',
  teal: '#008080',
  white: '#ffffff',
  yellow: '#ffff00'
};

/*
  the colour values accepted by this function are those
  defined by CSS 2.1, with the exception of
  "system colours".

  colour values are assumed to be from the browser, not
  direct from the user, so we need not validate
  them.
*/
function standardised_colour(colour) {
  if(/^#([0-9a-f]{3}){1,2}$/.test(colour)) {
    colour =
      colour.toLowerCase().replace(/#(.)(.)(.)$/, '#$1$1$2$2$3$3');
  } else if(/^rgb\(/.test(colour)) {
    var t = '[^\\d\\.]([\\d.]+)';
    var regex = new RegExp([t, t, t].join('[\\s\\S]*'));
    var numbers = regex.exec(colour).slice(1);
    necessary(numbers.length == 3);
    if(/%/.test(colour)) {
      for(var i = 0; i < 3; i++) {
	numbers[i] =
	  Math.max(0, Math.min(255,
	    Math.round(parseFloat(numbers[i]) * 2.55)));
      }
    }
    colour = phpjs.vsprintf('#%02x%02x%02x', numbers);
  } else if(keyword_to_hex_colour.hasOwnProperty(colour)) {
    colour = keyword_to_hex_colour[colour];
  } else
    throw new Error('unrecognised colour: [' + colour + ']');

  return colour;
}

function test_standardised_colour(colour) {
  var wanted_result = {
    lime: '#00ff00',
    '#0ff': '#00ffff',
    '#0ffeee': '#0ffeee',
    'rgb(128,\n\n0,255)': '#8000ff',
    'rgb(20%, 40.1%, 60.00001%)': '#336699',
    'rgb(99.99%, 99.99%, 99.999907%)': '#ffffff',

    '#0ffee': 'Error: unrecognised colour: [#0ffee]',
    'abcd': 'Error: unrecognised colour: [abcd]'
  };

  var divergences = '';

  for(var i in wanted_result) {
    try {
      var result = standardised_colour(i);
    } catch(ex) {
      result = ex.toString();
    }

    if(result !== wanted_result[i]) {
      divergences += phpjs.sprintf('<%s> <%s> <%s>\n\n',
	i, result, wanted_result[i]);
    }
  }

  if(divergences !== '') {
    alert(divergences);
  } else
    alert('no errors found by test_standardised_colour');
}

var hex_colour_to_keyword = obj_flip(keyword_to_hex_colour);

function as_keyword_if_possible(hex_colour) {
  return hex_colour_to_keyword.hasOwnProperty(hex_colour)?
    hex_colour_to_keyword[hex_colour]: hex_colour;
}

function in_array(value, array) {
  return $.inArray(value, array) > -1;
}

function hyphenated_version(camel_case_name) {
  var result =
    camel_case_name.replace(
      /[a-z][A-Z]/g,
      function (match) {
	return match.charAt(0) + '-' + match.charAt(1).toLowerCase();
      }
    );
  return result;
}

function set_dialog_content_width(dialog_content_element,
  new_value)
{
  set_dialog_content_dimension(dialog_content_element,
    'width', new_value)
}

function set_dialog_content_dimension(dialog_content_element,
  dimension_name, new_value)
{
  assert(/^(width|height)$/.test(dimension_name));
  var dialog_box =
    dialog_content_element.closest('.ui-dialog');
  var diff = dialog_box[dimension_name]() -
    dialog_content_element[dimension_name]();
  dialog_content_element.
    dialog('option', dimension_name, new_value + diff);
  dialog_content_element.
    dialog('option', 'position', 'center');
}

/*
  this function adds a prefix to CSS classes.
  "nsc": "namespace classes".
*/
function nsc(s) {
  var prefix = window.scinap.CSS_class_namespace_prefix;
  assert(prefix.indexOf('$') === -1);

  if(/\./.test(s)) {
    return s.replace(/\./g, '.' + prefix);
  } else {
    var result =
      s.replace(/(^|\s)(\S)/g, '$1' + prefix + '$2');
    return result;
  }
}

function obj_iter(object, func) {
  for(var prop_name in object)
    if(({}).hasOwnProperty.call(object, prop_name))
      func(prop_name, object[prop_name]);
}

/*
  replace obj_iter with a (presumably) more efficient version
*/
obj_iter = (
  function () {
    var hasOwnProperty = ({}).hasOwnProperty;
    var result =
      function (object, func) {
	for(var prop_name in object)
	  if(hasOwnProperty.call(object, prop_name))
	    func(prop_name, object[prop_name]);
      };
    return result;
  }
)();

function obj_extend(dst_object, src_object) {
  obj_iter(
    src_object,
    function (name, val) { dst_object[name] = val; }
  );
}

function obj_copy(object) {
  var new_obj = {};
  obj_extend(new_obj, object);
  return new_obj;
}

function obj_restrict(object, props) {
  var flipped = obj_flip(props);
  for(var i = 0; i < props.length; i++) {
    var prop = props[i];
    if(!flipped.hasOwnProperty(prop))
      delete object[props[i]];
  }
}

function obj_flip(object) {
  var result = {};
  obj_iter(
    object,
    function (name, val) { result[val] = name; }
  );
  return result;
}

function max_child_width(element) {
  var result =
    Math.max.apply(
      Math,
      element.children().
	map(function () { return $(this).outerWidth(true); }).
	get()
    );
  return result;
}

function assert(condition, extra_info) {
  terminate_if_false(condition, 'assertion failed', extra_info);
}

function necessary(condition, extra_info) {
  terminate_if_false(condition, 'necessary condition does not obtain',
    extra_info);
}

function terminate_if_false(condition, intro_message, extra_info) {
  if(!condition) {
    var message =
      intro_message + (extra_info == null? '': ': ' + extra_info);

    try {
      /*
	this should help in IE 8 if Firebug Lite is loaded:
	it should mean we don't have to click on the little
	yellow icon to discover what went wrong
      */
      console.error(message); 
    } catch(dummy) {}

    throw new Error(message);
  }
}

function create_class() {
  var parts = {
    shared: {},
    constructor: function () {},
    method_implementation: {}
  };

  var destination = {
    function01: 'constructor',
    object01: 'method_implementation',

    function02: 'constructor',
    function12: 'constructor',
    object02: 'shared',
    object12: 'method_implementation',

    function13: 'constructor',
    object03: 'shared',
    object23: 'method_implementation'
  };

  var len = arguments.length;

  for(var i = 0; i < len; i++) {
    var key = type(arguments[i]) + i + len;

    if(destination.hasOwnProperty(key)) {
      parts[destination[key]] = arguments[i];
    } else
      throw new Error('invalid arguments');
  }

  for(var prop in parts.method_implementation)
    if(parts.method_implementation.hasOwnProperty(prop))
      parts.constructor.prototype[prop] =
	parts.method_implementation[prop];

  for(var prop in parts.shared)
    if(parts.shared.hasOwnProperty(prop))
      parts.constructor[prop] = parts.shared[prop];

  if(0) {
    console.dir(parts.constructor);
    console.dir(parts);
  }

  return parts.constructor;

  function type(x) {
    return x == null? String(x):
      ({}).toString.call(x).slice(8, -1).toLowerCase();
  }
}

function pixel_size(measurement) {
  var tmp =
    $('<div/>',
      {
	position: 'absolute',
	display: 'block',
	visibility: 'hidden',
	width: measurement
      }
    ).prependTo($('body'));
  var result = tmp.width();
  tmp.remove();
  return result;
}

/*
  based on code in zakas's book
*/
function load_style_string(css) {
    var style = document.createElement("style");
    style.type = "text/css";
    var text = document.createTextNode(css);
    try {
	style.appendChild(text);
    } catch (ex){
	style.styleSheet.cssText = css;
    }
    var head = document.getElementsByTagName("head")[0];
    head.appendChild(style);

    return style;
}


})(jQuery);
