/*
  This code is not part of the application.
  It was used to generate an initialiser which appears
  in the Scinap code.

  It would be a waste of time to make this attractive or efficient.
*/

function show_initialiser() {
  $('body').empty();

  var most_econ = generate_initialiser();

  var distinctness_codes = [];
  obj_iter(
    most_econ,
    function (name) { distinctness_codes.push(name); }
  );
  distinctness_codes.sort();

  var textarea_text =
    $.map(
      distinctness_codes,
      function (code) {
	var val = most_econ[code];
	var result =
	  phpjs.sprintf(
	    "'%s': { border_color_indices: [%s], corrections: [%s] }",
	    code, val.border_color_indices.join(', '),
	      val.corrections.join(', '));
	return result;
      }
    ).join(',\n') + '\n';

  $('body').prepend(
    $('<textarea/>', { rows: 15, cols: 65 }).text(textarea_text)
  );
}

if(0) {
  var debug = function (msg) {
    //console.log(msg); return;
    if(!('debug_area' in window)) {
      window.debug_area = $('<div/>').appendTo('body');
    }
    debug_area.append($('<pre/>').css('outline', 'solid 1px red').text(msg));
  }
}

function generate_initialiser() {
  console.time('x');
  var best = {}
  var combination = new Array(4);

  /*
    it doesn't matter what colours are used here, as long
    as they're all different
  */
  var distinct_colours =
    '1 2 3 4'.replace(/\d/g, '#00000$&').split(' ');

  for(var num_distinct_colours = 1;
    num_distinct_colours <= distinct_colours.length;
    num_distinct_colours++)
  {
    score_combinations(3);
  }

  console.timeEnd('x');

  return best;

  function score_combinations(pos) {
    for(var i = 0; i < num_distinct_colours; i++) {
      combination[pos] = distinct_colours[i];
      if(pos > 0) {
	score_combinations(pos - 1);
      } else {
	var manager = new Border_colour_manager(combination);
	var distinctness = manager.distinctness();
	for(var j = 1; j <= 4; j++) {
	  var permutations_of_indices =
	    choose_permutation([0, 1, 2, 3], j);

	  for(var k = 0; k < permutations_of_indices.length; k++) {
	    var index_choices = permutations_of_indices[k];
	    var choices =
	      $.map(index_choices,
		function (index) { return combination[index]; });

	    var tmp = new Border_colour_manager(choices);
	    var colours = tmp.get_colours(4);
	    var corrections = [];
	    for(var m = 0; m < combination.length; m++) {
	      if(combination[m] != colours[m]) {
		corrections.push(m);
	      }
	    }

	    var candidate_solution = {
	      border_color_indices: index_choices.concat(),
	      corrections: corrections.concat()
	    };

	    if(0) {
	      if(distinctness === '0121' && choices.length == 3)
		debug(phpjs.sprintf('%s: [%s] [%s]', distinctness,
		  index_choices.join(', '), corrections.join(', ')));
	    }

	    if(!best.hasOwnProperty(distinctness) ||
	      compare(candidate_solution, best[distinctness]) < 0)
	    {
	      best[distinctness] = candidate_solution;
	    }
	  }
	}
      }
    }

    function compare(solution1, solution2) {
      var num_colours1 =
	solution1.border_color_indices.length +
	  solution1.corrections.length;
      var num_colours2 =
	solution2.border_color_indices.length +
	  solution2.corrections.length;
      var diff = num_colours1 - num_colours2;
      var result;
      if(diff == 0) {
	result =
	  sign(
	    solution1.corrections.length -
	      solution2.corrections.length
	  );
      } else {
	result = sign(diff);
      }

      return result;

      function sign(x) {
	return x < 0? -1: (x > 0? 1: 0);
      }
    }

    function choose_permutation(array, num_elements) {
      var result = [];
      var scratch_array = new Array(num_elements);

      var taken = new Array(num_elements);
      for(var i = 0; i < taken.length; i++)
	taken[i] = false;

      choose_from_remaining(num_elements);

      assert(result.length == expected_result_len());

      return result;

      function choose_from_remaining(num_elements_left) {
	if(num_elements_left === 0) {
	  result.push(scratch_array.concat());
	} else {
	  for(var i = 0; i < array.length; i++) {
	    if(!taken[i]) {
	      scratch_array[num_elements - num_elements_left] =
		array[i];
	      taken[i] = true;
	      choose_from_remaining(num_elements_left - 1);
	      taken[i] = false;
	    }
	  }
	}
      }

      function expected_result_len() {
	var n = array.length;
	var result = 1;
	for(i = 0; i < num_elements; i++) {
	  result *= n;
	  n--;
	}
	return result;
      }
    }
  }
}
